/* Bit-twiddling combination generator
   Doug Moore (dougm@rice.edu) (C) 1993

   April 4, 1997: made START, and LEAST_ITEM  macros instead of functions.
   Improved START.  eliminated function calls for first and last comb.
   Eliminated the assertions.  Improved the style of the main loop.
   Glenn Rhoads
*/

#include <stdio.h>
#include <stdlib.h>

#define START(I)       ((1<<(I)) - 1)
#define LEAST_ITEM(I)  ((I) & -(I))

typedef unsigned long set_type;

set_type NextComb( set_type);


void main(void)
{
  int d, s;
  set_type lastComb;
  set_type comb;

  printf( "Enter n,k: ");
  scanf( "%d,%d", &d, &s);

  if (s > d) return;

  comb = START(s);   
  lastComb = comb << (d-s);
  printf("%lu\n", comb);

  while (comb != lastComb)
      {
      comb = NextComb(comb);
      printf("%lu\n", comb);
      }
}


set_type NextComb(set_type comb)
{
  set_type hibit;
  set_type lobit = LEAST_ITEM(comb);
  comb += lobit;
  hibit = LEAST_ITEM(comb);
  hibit -= lobit;
  while (!(hibit&1)) hibit >>= 1;
  comb |= hibit >> 1;
  return comb;
}

