#include <stdio.h>
#include <conio.h>
#define MAXN 10
int prodNb; // cross product ordering number
int p[MAXN]; // vector holding currently generated product
int nElem[MAXN]; // number of elements per set
int printedLinesCount; // count of printed lines so far
/***********************************************************
* FUNCTION NAME: showProduct
*
* DESCRIPTION:  shows a set crossproduct
*
* ARGUMENT LIST:
* Argument        Type   IO      Description
* ------------- -------- -- --------------------------------
* int           n       I   number ofelements to show

* RETURN VALUE: void
*
* CHANGES: -
*************************************************************/
void showProduct(const int n)
{
    int i;

    printf("\n%3d ", prodNb);
    for (i = 1; i <= n; i++) printf(" %2d", p[i]);
    if ( printedLinesCount++ % 24 == 0 ) getchar();
}
/***********************************************************
* FUNCTION NAME: crossProdRec
*
* DESCRIPTION:  generates the elements of the cross product
*               of n sets and prints them to stdout
*
* ARGUMENT LIST:
* Argument        Type   IO      Description
* ------------- -------- -- --------------------------------
* int           n         I number of sets;
* int           i         I index of current set in nElem
* RETURN VALUE: void
*
* CHANGES: global vector p; global variable prodNb
*************************************************************/
void crossProdRec(int n, int i)
{
    int j;

    for (j = 1; j <= nElem[i]; j++)
    {
        p[i] = j;
        if (i < n) crossProdRec(n, i+1);
        else
        {
            prodNb++;
            showProduct(n);
        }
    }
}
int main(int argc, char *argv[])
{
    int i, n;
    printf("Number of sets [<%d]=", MAXN);
    scanf("%d%*c", &n);
    printedLinesCount++;
    for (i = 1; i <= n; i++)
    {
        printf("Number of elements in set %d=", i);
        scanf("%d%*c", &nElem[i]);
        printedLinesCount++;
    }
    printf("The members of the cross product");
    printf("\nNo.   Elements");
    printedLinesCount += 2;
    crossProdRec(n, 1);
    return 0;
}
