/* Program L11Ex2.c */

#include <stdio.h>
#include <stdlib.h>
/* Illustrates binary file processing */
typedef struct
{
    char name[40];
    long sum;
    /*other members */
} RecordT;

void showContents(const char *filename)
{
    FILE *pf;
    RecordT buf;
    int i;

    pf=fopen(filename, "rb");
    if (!pf) /// check for successful open
    {
        perror(filename);
        exit(2);
    }
    printf("\nNO.    SUM        FAMILY NAME-FIRST NAME\n");
    i=0;
    while (fread(&buf, sizeof(RecordT), 1, pf) > 0)
    {
        printf("\n%6d %10ld       %-40s", i, buf.sum, buf.name);
        i++;
    }
    fclose(pf);
}
void createFile(const int n, const char *filename)
{
    FILE *pf;
    RecordT buf;
    int i;

    pf=fopen(filename, "wb");
    if (!pf) /// check for successful open
    {
        perror(filename);
        exit(1);
    }
    for (i=1; i<=n; i++)
    {
        printf("Family name and first name of the person: ");
        fgets(buf.name, sizeof(buf.name), stdin);
        printf("Sum = ");
        scanf(" %ld%*c", &buf.sum);
        fwrite(&buf, sizeof(RecordT), 1, pf);
    }
    fclose(pf);

}

int main(void)
{
    char file_name[40]="file.dat";
    int n;
    /*Create file */
    printf("\nInput the number of persons, n=");
    scanf("%d%*c", &n);
    createFile(n, file_name);
    printf("\nFile contents:\n");
    showContents(file_name);
    return 0;
}
