#include <stdio.h>
#include <stdlib.h>
#define MAXN 200
int v[MAXN]; // used by permRec
int cardV; // used by permRec = number of elements in v
// swap 2 integers
void swap(int *i, int *j)
{
    int temp;
    temp = *i;
    *i = *j;
    *j = temp;
}
// revert part of array
void revert(int p[], int i, int n, int k)
{
    int j;
    for (j = 1; j <= k; j++)
        swap(&p[i + j], &p[n + 1 - j]);
}
// list permutation
void listPerm(int n, int permNb, int p[])
{
    printf("%d: ", permNb);
    for (int i = 1; i <= n; i++)
        printf("%d ", p[i]);
    printf("\n");
}
// non recursive permutation generation
void permNonRec(int n)
{
    int p[MAXN];
    int i, k, permNb = 0;

    /* first permutation, step a */
    for (i = 1; i <= n; i++) p[i] = i;
    listPerm(n, ++permNb, p);
    do /* generate the next permutations */
    {
        i = n - 1;
        while (p[i] > p[i+1] && i > 0) i--; /* step b1 */
        if (i > 0)
        {
            for (k = n; p[i] > p[k]; k--); /* step b2 */
            swap( &p[i], &p[k] );  /* step b3 */
            revert(p,  i, n, (n - i ) / 2);
            listPerm(n, ++permNb, p);
        }
    } while (i > 0);
}
// recursive permutation generation
// uses global array v and global int cardV
void permRec(int n)
{
    static int permNb = 0;
    if (n == 1)
        listPerm(cardV, ++permNb, v);
    else
    {
        permRec(n - 1);
        for (int i=1; i <= n-1; i++)
        {
            swap(&v[i], &v[n]);
            permRec(n - 1);
            swap(&v[i], &v[n]);
        }
    }
}
int main()
{
    printf("Non-recursive permutations generation\n");
    permNonRec(4);
    printf("Recursive permutations generation\n");
    for(int i = 1; i <= 4; i++) v[i] = i;
    cardV = 4;
    permRec(4);
    return 0;
}
