#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "sortUtils.h"

void fatalError(const char *msg)
{
    fputs(msg, stderr);
    exit(1);
}
/* swap exchanges the values of x and y */
void swap( void *px, void *py, size_t size)
{
	void *ptemp;

	if (NULL==(ptemp=malloc(size)))
		fatalError("No memory");
	memcpy(ptemp, px, size);
	memcpy(px, py, size);
	memcpy(py, ptemp, size);
    free(ptemp);
}	/* swap */

int cmpkey(void *pk1, void *pk2, size_t size)
{ // example for objects stored in high to low value order
	return(memcmp(pk1, pk2, size));
}

void inssort(recordT A[], int size)
{
    static int min = 0;
    int i, j;

    memcpy(&A[0].key, &min, sizeof(keyT));
    for (i = 1; i < size; i++)
    {
        j = i;
        while (cmpkey(&A[j].key, &A[j-1].key, sizeof(keyT)) < 0)
        {
            swap( &A[j], &A[j-1], sizeof(recordT));
            j--;
        }
    }
} /* inssort */

enum {FALSE, TRUE};
void bubblesort(recordT A[], int size)
{
    int i, j, done = FALSE;

    for (i = 0; i < size && !done; i++)
    {
        done = TRUE;
        for (j = size - 1;  j > i;  j--)
        {
            if  (cmpkey(&A[j].key, &A[j-1].key, sizeof(keyT)) < 0)
            {
                swap(&A[j], &A[j-1], sizeof(recordT));
                done = FALSE;
            }
        }

    }
} /* bubblesort */
